
{    .                  }
{     (C)  Fwcs Corporation   18/VII/2000.  }
{    "".                                  }


{   Borland Delphi 3.0.                   }
unit variat1;

interface


{  . }
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, ExtCtrls, Spin;


{  . }
type
  Tf_Variat = class(TForm)     {   .        }
    f_PanTbl: TPanel;          {    .      }
    f_PalCom: TPanel;          {   .         }
    f_PanPnt: TPanel;          {    .      }
    f_TxtHdr1: TLabel;         { -1       }
    f_TxtHdr2: TLabel;         { -2  .    }
    f_PrgName: TLabel;         {   .        }
    f_Table: TStringGrid;      {   .     }
    f_EdCell: TEdit;           {  . - .  }
    f_ClrList: TListBox;       {    - .   }
    f_Image: TImage;           {  " '".  }

    f_TxtPNm: TLabel;          {  " ". }
    f_EdtPNm: TEdit;           {    .  }
    f_TxtScoP: TLabel;         {  " ". }
    f_EdtScoP: TEdit;          {    .  }
    f_TxtScoN: TLabel;         {  "- ". }
    f_EdtScoN: TEdit;          {   - .  }
    f_TxtCurP: TLabel;         {  " ".   }
    f_EdtCurP: TEdit;          {    ".    }
    f_TxtXre: TLabel;          {  ". ". }
    f_EdtXre: TEdit;           {   . ". }

    f_ButTabl: TButton;        {  "  ".     }
    f_ButProt: TButton;        {  "  ".   }
    f_ButLoad: TButton;        {  "".              }
    f_ButSave: TButton;        {  "".              }
    f_NewNam: TButton;         {  " ".           }
    f_NewData: TButton;        {  " ".        }
    f_ButInfo: TButton;        {  "".             }
    f_ButQuit: TButton;        {  "  ".  }

    f_ButPrev: TButton;        {  " ".    }
    f_ButNext: TButton;        {  " ".     }
    f_ButDelP: TButton;        {  " . ". }
    f_ButQlist: TButton;       {  "  ".  }

{    . }
    procedure f_TableSelectCell(Sender: TObject;
      Col, Row: Integer; var CanSelect: Boolean);
    procedure f_TableKeyPress(Sender: TObject; var Key: Char);
    procedure f_EdtScoNChange(Sender: TObject);

{    . }
    procedure f_ButTablClick(Sender: TObject);
    procedure f_ButProtClick(Sender: TObject);
    procedure f_NewDataClick(Sender: TObject);
    procedure f_ButInfoClick(Sender: TObject);
    procedure f_ButQuitClick(Sender: TObject);

{    . }
    procedure f_ButPrevClick(Sender: TObject);
    procedure f_ButNextClick(Sender: TObject);
    procedure f_ButDelPClick(Sender: TObject);
    procedure f_ImageDblClick(Sender: TObject);
    procedure f_ButQlistClick(Sender: TObject);

{     . }
    function  f_ValDS(st:String):Real;
    function  f_StrSD(nm:Real):String;
    function  f_FulSpc(sco:Integer):String;
    function  f_ChangeWinDos(ch:Char):Char;
    procedure f_PrnStr(ss:String);

{   (  ). }
    procedure PutEdtTabl;
    procedure SaveFields;
    procedure LoadFields;
    procedure GetScheme;
    procedure Rascot;
    procedure Rascot1;
    procedure Rascot2;
    procedure ResultScr;
    procedure ResultPrn;
    procedure Result;
    procedure ViewList;

  private                      { Private declarations.         }
  public                       { Public declarations.          }
  end;


{   . }
const
  MAXpoint =  30 ;             {   .     }
  MAXrows  =  14 ;             {   . }
  MAXlines = 252 ;             {    .  }
  c_EoL:String=Chr(13)+Chr(10);{    .  }


{  . }
var
 {    Windows. }
  f_Variat: Tf_Variat;         {  .             }
  f_CurRow:Integer=13;         {                 }
  f_CurCol:Integer=0;          {    .           }

 {   . }
  ErrCod    :Integer;          {        }
  line:Integer;                {    .     }
  f_Scheme  : Integer;         {   .    }

  f_ScoP : Integer;            {  .             }
  f_ScoN : Integer;            {  .         }
  f_CurP : Integer=1;          {  .                }
  f_VaSrM: Real;               {     }
  f_VaSrB: Real;               {      .   }
  f_SKO  : Real;               {  . .  }
  f_Sis  : Real;               {  .  }
  f_Var  : Real;               { .                     }

 {   . }
  f_Xre : Array[1..MAXpoint] of Real;
 {   . }
  f_X   : Array[0..1, 1..MAXpoint, 1..MAXrows] of Real;
 {    . }
  f_Xva : Array[0..1, 1..MAXpoint, 1..MAXrows] of Real;


{  . }
implementation
{$R *.DFM}
{$B+}


{ ---===---  -  ---===--- }


{     . }
function Tf_Variat.f_ValDS(st:String):Real;
var temp:Real;                 { . .  .  }
begin
  if st<>'' then
    begin
    Val(st, temp, ErrCod);     {    .}
    f_ValDS := temp;           {   . }
    if ErrCod <> 0 then        {     :   }
      MessageDlg('  : ' + IntToStr(ErrCod),
                  mtWarning, [mbOk], 0);
    end
  else f_ValDS:=0;
end;


{     . }
function Tf_Variat.f_StrSD(nm:Real):String;
var
  temp:String;                 { . .  .  }
  leng:Integer;                {  .                 }
  maxp:Integer;                {  .            }
  indx:Integer;                {  .      }
  flag:Integer;                {  .            }
begin
  Str(nm:0:10, temp);          {    .}

 {   . }
  leng := Length(temp) ;       {   .       }
  indx := leng;                {    .      }
  maxp := Pos('.',temp);       {    .     }
  flag:=1;                     {   .      }
  if (maxp<>0) then            {   ,  .   }
    begin
    While ((indx>maxp) And (Flag=1)) do    {  ,    }
      begin                                {  . }
      if temp[indx]<>'0' then  flag:=0;    {   .}
      Dec(indx);                           {  .  }
      end;
    if (indx=maxp) And (temp[indx+1]='0')  {   :}
      then  Dec(indx,2);                   {   .}
    Delete(temp,indx+2,leng-indx-1);       {   0.}
  end;
  f_StrSD := temp;             {   . }
end;


{   . }
procedure Tf_Variat.f_PrnStr(ss:String);
var
  FileHandle : Integer;        {   ( DOS).    }
  FileName:String;             {   (>prn).             }
  SymbArr:Array[1..255]of Char;{    DOS.       }
  i,lss:Integer;               {  .   . }
begin
  ss:=ss+c_EoL;                {   .  }
  lss:=Length(ss);             {   .       }
  for i:=1 to lss do           {  .        }
    SymbArr[i]:=f_ChangeWinDos(ss[i]);

  FileName:='prn';                     {  : "". }
  FileHandle := FileOpen(FileName,     {          }
   fmOpenWrite or fmShareDenyNone);    {   .           }
  FileWrite(FileHandle, SymbArr, lss); {  .        }
  FileClose(FileHandle);               {  .       }
end;


{    'sco' . }
function Tf_Variat.f_FulSpc(sco:Integer):String;
var
  i     :Integer;              {  .          }
  s_out :String;               {  .        }
begin
  s_out:='';
  if (sco>0) And (sco<255) then{   .    }
    begin
    for i:=1 to sco do         {    .      }
      s_out:=s_out+'_';        {    .   }
    end;
  f_FulSpc:=s_out;             {  .         }
end;


{  Windows=>Dos. }
{    Windows . }
{    MS-DOS . }
function Tf_Variat.f_ChangeWinDos(ch:Char):Char;
var
  retu:Byte;                   {  .          }
begin
  retu:=Ord(ch);               {   - .}
  if (retu >= 128) then        {  ASCII,   . }
    if (retu<(128+33))
      then retu:=retu-64       {   .       }
      else                     {   .     }
        if (ch<='')
          then retu:=retu-64   { .   '' .   }
          else  retu:=retu-16; { .   ''  ''.    }

  if (ch='') then  retu:=240; {   ''.           }
  if (ch='') then  retu:=241; {   ''.           }
  if (ch='') then  retu:=252; {   ''.            }

  f_ChangeWinDos:=Chr(retu);   {   .     }
end;



{ ---===---  . ---===--- }


{     .}
procedure Tf_Variat.PutEdtTabl;
begin
  f_Table.Cells[f_CurCol,f_CurRow]:=f_EdCell.Text;
end;


{     . }
procedure Tf_Variat.SaveFields;
var
  j,k :Integer;                {  .          }
  s :String;                   {    . }
begin
 {  . }
  f_ScoP := Round(f_ValDS(f_EdtScoP.Text));
  f_ScoN := Round(f_ValDS(f_EdtScoN.Text));

 {    . }
  PutEdtTabl;                  {    =>  .  }
  f_CurP := Round(f_ValDS(f_EdtCurP.Text));  {  .  }
  if f_EdtXre.Text<>'' then                  {   - }
    f_Xre[f_CurP] := f_ValDS(f_EdtXre.Text); {   . }

 {    . }
  for k:=0 to 1 do                   {   /.            }
    for j:=1 to f_ScoN do            {   .     }
      begin
      s:=f_Table.Cells[k,j-1];       {    .}
      if s<>'' then                  {    ,   }
        f_X[k,f_CurP,j]:=f_ValDS(s); {   .          }
      end;
end;


{     . }
procedure Tf_Variat.LoadFields;
var
  j,k :Integer;                {  .          }
begin
 {    . }
  for k:=0 to 1 do
    for j:=1 to f_ScoN do
      f_Table.Cells[k,j-1]:=f_StrSD(f_X[k,f_CurP,j]);

 {    . }
  f_EdtXre.Text:=f_StrSD(f_Xre[f_CurP]);
  f_EdCell.Text:=f_Table.Cells[f_CurCol,f_CurRow];
end;


{    . }
procedure Tf_Variat.GetScheme;
begin
  if f_ScoN=1 then f_Scheme:=1 else f_Scheme:=2;
end;


{   . }
procedure Tf_Variat.Rascot;
begin
  GetScheme;                   {    .     }
  if f_Scheme=1 then Rascot1 else Rascot2;
end;


{       . }
procedure Tf_Variat.Rascot1;
var
  i,k :Integer;                {  .          }
  sum1,sum2:Real;              {   .            }
begin

 {    .}
  for k:=0 to 1 do
    for i:=1 to f_ScoP do
      f_Xva[k,i,1]:=Abs(f_X[k,i,1]-f_Xre[i]);

 {     . }
  sum1:=0; sum2:=0;
  for i:=1 to f_ScoP do
    begin
    sum1:=sum1+f_Xva[0,i,1];
    sum2:=sum2+f_Xva[1,i,1];
    end;
  f_VaSrM:=sum1/f_ScoP; f_VaSrB:=sum2/f_ScoP;

 {    ( .). }
  sum1:=0; sum2:=0;
  for i:=1 to f_ScoP do
    begin
    sum1:=sum1+(f_Xva[0,i,1]-f_VaSrM)*(f_Xva[0,i,1]-f_VaSrM);
    sum2:=sum2+(f_Xva[1,i,1]-f_VaSrB)*(f_Xva[1,i,1]-f_VaSrB);
    end;
  f_SKO:=sqrt((sum1+sum2)/(2*f_ScoP-1));
  f_Sis:=(f_VaSrM+f_VaSrB)/2;
  f_Var:=Abs(f_VaSrM-f_VaSrB);
end;


{       . }
procedure Tf_Variat.Rascot2;
var
  i,j :Integer;                {  .          }
  sum1:Real;                   {   .            }
begin

 {   (  . }
  for i:=1 to f_ScoP do
    begin
    sum1:=0;
    for j:=1 to f_ScoN do
      sum1:=sum1+(f_X[0,i,j]+f_X[1,i,j])/2;
    f_Xre[i]:=sum1/f_ScoN;
    end;

  Rascot1;                     {  -  -1. }
end;


{    . }
procedure Tf_Variat.ResultScr;
begin
  ViewList;                    {   .  }
  Result;                      {    .    }
end;


{    . }
procedure Tf_Variat.ResultPrn;
var
  i :Integer;                  {  .          }
  s :TStrings;                 {   .        }
begin
  Result;                      {    .    }
  s := f_ClrList.Items;        {  .                 }

  for i:=0 to line do
    begin
    f_PrnStr(s[i]);
    end;
end;


{     . }
procedure Tf_Variat.Result;
var
  s :TStrings;                 {   .        }
  i,j :Integer;                {  .          }
begin
  s := f_ClrList.Items;        {  .                 }

{   . }
  line:=0;

 {  . }
  s[line+0] := '       "Variation".';
  s[line+1] := '';
  s[line+2] := ' : '+f_EdtPNm.Text;
  s[line+3] := ' ='+f_StrSD(f_ScoP);
  s[line+4] := ' ='+f_StrSD(f_ScoN);
  Inc(line,6);
  for i:=1 to f_ScoP do
    begin
    s[line+0] := ' '+f_StrSD(i);
    if f_Scheme=1 then
      s[line+1] := '    ='+f_StrSD(f_Xre[i]);
    if f_Scheme=2 then
      s[line+1] := '    ='+f_StrSD(f_Xre[i]);
    s[line+2] := '    :';
    Inc(line,3);
    for j:=1 to f_ScoN do
      begin
      s[line+0] := '      '+f_StrSD(j)+
                       '   ='+f_StrSD(f_X[0,i,j]);
      s[line+1] := '      '+f_StrSD(j)+
                       '  ='+f_StrSD(f_X[1,i,j]);
      Inc(line,2);
      end;
    Inc(line,1);
    end;

 {  . }
  s[line+0] := '      ='
               +f_StrSD(f_VaSrM);
  s[line+1] := '       ='
               +f_StrSD(f_VaSrB);
  s[line+2] := '     ='
               +f_StrSD(f_SKO);
  s[line+3] := '    ='
               +f_StrSD(f_Sis);
  s[line+4] := '   ='
               +f_StrSD(f_Var);
  Inc(line,5);
end;



{ ---===---    ---===--- }


{   . }
procedure Tf_Variat.ViewList;
var
  s :TStrings;
  i :Integer;                  {  .          }
begin
  f_ClrList.Left    :=   4;
  f_ClrList.Top     :=  30;
  f_ClrList.Width   := 696;
  f_ClrList.Height  := 374;
  f_ClrList.Visible := True;
  f_ButQlist.Left   := 556;
  f_ButQlist.Top    := 374;
  f_ButQlist.Visible:= True;

  s := f_ClrList.Items;        {  .                 }
  for i:=0 to MAXlines do      {                  }
    s[i]:='';                  {  .                     }
end;


{    . }
procedure Tf_Variat.f_TableSelectCell(Sender: TObject;
  Col, Row: Integer; var CanSelect: Boolean);
var kk:Integer;
begin
  PutEdtTabl;                  {    =>  .  }
  f_CurCol:=Col;  f_CurRow:=Row;
  f_EdCell.Text:=f_Table.Cells[f_CurCol,f_CurRow];
  kk:=f_Table.GridLineWidth;
  f_EdCell.Left:=f_Table.Left+Col*(f_Table.DefaultColWidth+kk);
  f_EdCell.Top:=f_Table.Top+Row*(f_Table.DefaultRowHeight+kk);
end;


{      . }
procedure Tf_Variat.f_TableKeyPress(Sender: TObject; var Key: Char);
var i:Integer;
    s:String;                  {    . }
begin
  if (Key>='0') and (Key<='9') or (Key='.') then
    f_EdCell.Text:=f_EdCell.Text+Key
  else
    if Ord(Key)=8 then
      begin
      s:=f_EdCell.Text;
      i:=Length(s);
      if i>0 then  SetLength(s,i-1);
      f_EdCell.Text:=s;
      end;
end;


{    "Variat". }
procedure Tf_Variat.f_ButQuitClick(Sender: TObject);
begin
  Close;
end;


{    . }
procedure Tf_Variat.f_ButInfoClick(Sender: TObject);
var
  s :TStrings;                 {   .        }
begin
  ViewList;                    {   .  }
  s := f_ClrList.Items;        {  .                 }

 {   . }
  s[0] := '                       .';
  s[2] := '       "Variation"   '
         +'       ';
  s[3] := '  .';
  s[5] := '          :'
         +'    ';
  s[6] := '.   ,     '
         +'   .';
  s[7] := '       '
         +'   ';
  s[8] := '      '
         +'  ,';
  s[9] := '    -  '
         +'  .';
  s[10] := '';
end;


{    . }
procedure Tf_Variat.f_ButQlistClick(Sender: TObject);
begin
  f_ButQlist.Visible:= False;  {         }
  f_ClrList.Visible := False;  {     .            }
end;


{   "". }
procedure Tf_Variat.f_ButTablClick(Sender: TObject);
begin
  SaveFields;                  {    . }
  Rascot();                    {  .           }
  ResultScr();                 {  -  .      }
end;


{   . }
procedure Tf_Variat.f_ImageDblClick(Sender: TObject);
var
  s :TStrings;
begin
  ViewList;                    {   .  }
  s := f_ClrList.Items;        {  .                 }

 {   . }
  s[0] := '         "Variat"';
  s[1] := '   '+
          '    "".';
  s[13]:= '                               '+
          '(C)  Fwcs Corporation   14/VII/2000.';
end;


{   . }
procedure Tf_Variat.f_EdtScoNChange(Sender: TObject);
var i:Integer;
begin
  if f_EdtScoN.Text<>'' then
    begin
    i:=Round(f_ValDS(f_EdtScoN.Text));
    if i<=12 then f_Table.RowCount:=i;
    end
end;


{   " ". }
procedure Tf_Variat.f_ButNextClick(Sender: TObject);
begin
 {   . }
  if f_CurP<MAXpoint then
    begin
    SaveFields;                {    . }
    Inc(f_CurP);
    f_EdtCurP.Text:=f_StrSD(f_CurP);

 {   . }
    if f_CurP>f_ScoP then
      begin
       f_ScoP := f_CurP ;
       f_EdtScoP.Text:=f_StrSD(f_ScoP);
       SaveFields;
      end
    else LoadFields ;
    end;
end;


{   " ". }
procedure Tf_Variat.f_ButPrevClick(Sender: TObject);
begin
 {   . }
  if f_CurP>1 then
    begin
    SaveFields;                {    . }
    Dec(f_CurP);
    LoadFields;
    f_EdtCurP.Text:=f_StrSD(f_CurP);
    end;
end;


{   . }
procedure Tf_Variat.f_ButDelPClick(Sender: TObject);
var
  i,j,k :Integer;              {  .          }
begin
  if (f_ScoP>1) then  begin    {  ,  .    }
  Dec(f_ScoP);                 { :   .    }

  if (f_CurP = MAXpoint) then
    begin                      {   :          }
    Dec(f_CurP);               {    . }
    LoadFields ;
    end
  else                         {    :        }
    begin
    for i:=f_CurP+1 to MAXpoint do {   .   }
      begin
      for k:=0 to 1 do
        for j:=1 to f_ScoN do
          f_X[k,i-1,j]:=f_X[k,i,j];
      f_Xre[i-1]:=f_Xre[i];
      end;

    if (f_CurP<>1) then Dec(f_CurP) ;
    LoadFields ;
    end;

  f_EdtCurP.Text:=f_StrSD(f_CurP); {   .}
  f_EdtScoP.Text:=f_StrSD(f_ScoP); {  - .  }
                  end;
end;


{   "". }
procedure Tf_Variat.f_ButProtClick(Sender: TObject);
begin
  SaveFields;                  {    . }
  Rascot();                    {  .           }
  ResultPrn();                 {  -  .    }
end;


{    }
{    .      }
procedure Tf_Variat.f_NewDataClick(Sender: TObject);
var
  i,j,k :Integer;              {  .          }
begin
 {  . }
  for k:=0 to 1 do
    for i:=1 to MAXpoint do
      begin
      for j:=1 to MAXrows do
        begin
        f_X[k,i,j]:=0;
        end;
      f_Xre[i]:=0;
      end;

 {  . }
   f_ScoP:=1; f_EdtScoP.Text:='1';
   f_ScoN:=1; f_EdtScoN.Text:='1';
   f_CurP:=1; f_EdtCurP.Text:='1';
   f_EdtPNm.Text:='-';
   LoadFields;
end;

end.

